VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "FishFace50"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' -----------------------------------------------------------------------------
'
' FishFace50                                             Ulrich Mller 24.08.10
'                                                        Aspire  VBA Excel 2002
' FishFace fr den Robo TX Controller
'
' -----------------------------------------------------------------------------

' --- umFish50.DLL Declares ---------------------------------------------------

Private Declare Function txOpenController Lib "umFish50.DLL" _
    (ByVal ComNr&) As Long
Private Declare Function txCloseController Lib "umFish50.DLL" _
    () As Long

Private Declare Function txGetAnalog Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal inpNr&) As Long
Private Declare Function txGetDistance Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal inpNr&) As Long
Private Declare Function txGetInput Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal inpNr&) As Long
Private Declare Function txGetTrack Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal inpNr&) As Long
Private Declare Function txGetVoltage Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal inpNr&) As Long

Private Declare Function txGetCounter Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal cntNr&) As Long
Private Declare Function txClearCounter Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal cntNr&) As Long

Private Declare Function txSetLamp Lib "umFish50.DLL" _
    (ByVal ctrId%, ByVal outNr%, ByVal onOff&) As Long
Private Declare Function txSetMotor Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal motNr&, ByVal dir&, ByVal speed&) As Long
Private Declare Function txStartMotor Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal motNr&, ByVal dir&, ByVal speed&, _
     ByVal iCount&, ByVal robMode&) As Long
    
Private Declare Function txIsMotorReady Lib "umFish50.DLL" _
    (ByVal ctrId&, ByVal motNr&) As Long
  
Private Declare Sub txSleep Lib "umFish50.DLL" (ByVal mSek&)
Private Declare Function txEsc Lib "umFish50.DLL" () As Long
Private Declare Function txGetTickCount Lib "umFish50.DLL" () As Long

' --- Globale Variable ---------------------------
Private res As Long
Private ctrId As Long
Private Const txPollInterval = 12

' ----------- Konstruktor -----------------------------
Private Sub Class_Initialize()
    ctrId = 0
End Sub

Public Function OpenController(ByVal ComNr As Long) As Long
    OpenController = txOpenController(ComNr)
End Function
Public Sub CloseController()
    res = txCloseController()
End Sub

Public Property Get Device() As Long
    Device = ctrId
End Property
Public Property Let Device(nr&)
    ctrId = nr
End Property

Public Function Finish(Optional ByVal inpNr& = 0) As Boolean
    Finish = True
    If txEsc() <> 0 Then
        Exit Function
    ElseIf inpNr > 0 Then
        If GetInput(inpNr) Then Exit Function
    End If
    Finish = False
End Function

Public Sub Pause(ByVal mSek&)
    Dim sZeit&
    sZeit = txGetTickCount()
    Do
        If txEsc() <> 0 Then Exit Sub
        DoEvents
        txSleep txPollInterval
    Loop While (txGetTickCount() - sZeit < mSek)
End Sub

Public Function GetAnalog(ByVal inpNr&) As Long
    DoEvents
    GetAnalog = txGetAnalog(ctrId, inpNr - 1)
End Function
Public Function GetDistance(ByVal inpNr&) As Long
    DoEvents
    GetDistance = txGetDistance(ctrId, inpNr - 1)
End Function
Public Function GetInput(ByVal inpNr&) As Boolean
    DoEvents
    res = txGetInput(ctrId, inpNr - 1)
    GetInput = IIf(res = 0, False, True)
End Function
Public Function GetTrack(ByVal inpNr&) As Boolean
    DoEvents
    res = txGetTrack(ctrId, inpNr - 1)
    GetTrack = IIf(res = 0, True, False)
End Function
Public Function GetVoltage(ByVal inpNr&) As Long
    DoEvents
    GetVoltage = txGetVoltage(ctrId, inpNr - 1)
End Function

Public Function GetCounter(ByVal cntNr&) As Long
    GetCounter = txGetCounter(ctrId, cntNr - 1)
End Function
Public Sub ClearCounter(ByVal cntNr&)
    txClearCounter ctrId, cntNr - 1
End Sub

Public Sub SetLamp(ByVal outNr&, ByVal onOff As Boolean, Optional ByVal Power& = 512)
    DoEvents
    txSetLamp ctrId, outNr - 1, IIf(onOff, Power, 0)
End Sub

Public Sub SetMotor(ByVal motNr&, ByVal dir&, Optional ByVal speed = 512)
    DoEvents
    txSetMotor ctrId, motNr - 1, dir, speed
End Sub

Public Sub StartMotor(ByVal motNr&, ByVal dir&, ByVal speed&, ByVal iCount&)
    DoEvents
    txStartMotor ctrId, motNr - 1, dir, speed, iCount, 0
End Sub
Public Sub StartRobMotor(ByVal motNr&, ByVal dir&, ByVal speed&, ByVal iCount&)
    DoEvents
    txStartMotor ctrId, motNr - 1, dir, speed, iCount, 1
End Sub
Public Function StopMotor(ByVal motNr&) As Long
    SetMotor motNr, 0
    StopMotor = GetCounter(motNr)
    ClearCounter motNr
End Function

Public Function WaitForMotor(ByVal motNr&) As Long
    Dim res&
    Do
        res = txIsMotorReady(ctrId, motNr - 1)
        If res >= 0 Then Exit Function
    DoEvents
    Loop Until txEsc() <> 0
    WaitForMotor = res
End Function
Public Sub WaitForMotors(ParamArray motNr() As Variant)
    Dim i&, c&, res&
    Do
        c = 0
        For i = 0 To UBound(motNr)
            res = txIsMotorReady(ctrId, motNr(i) - 1)
            c = c + IIf(res < 0, 1, 0)
        Next
        If c = 0 Then Exit Sub
    DoEvents
    Loop Until txEsc() <> 0
End Sub
Public Sub WaitForCount(ByVal cntNr&, ByVal NrOfChanges&)
    Dim count&
    count = 0
    ClearCounter cntNr
    Do
        count = GetCounter(cntNr)
        txSleep txPollInterval
        If txEsc() <> 0 Then Exit Sub
        DoEvents
    Loop While count < NrOfChanges
End Sub
Public Sub WaitForInput(ByVal inpNr&, Optional ByVal onOff As Boolean = True)
    Do
        If txEsc() <> 0 Then Exit Sub
        DoEvents
        txSleep txPollInterval
    Loop Until GetInput(inpNr) = onOff
End Sub
Public Sub WaitForHigh(ByVal inpNr&)
    WaitForInput inpNr, False
    WaitForInput inpNr, True
End Sub
Public Sub WaitForLow(ByVal inpNr&)
    WaitForInput inpNr, True
    WaitForInput inpNr, False
End Sub
